############################################################
#                                                          #
#                 Load Observations                        #
#                                                          #
############################################################
#This script its called from UK to set the observations of Catalonia

# local_stations: special points data frame with two cols [NO2 and ref_obs-reference of station-], at the moment we have 72 stations in Cat
local_stations <- readRDS(file = paste0(sim_folder_path,"local_stations.rds"))
#we have a doc where we have the reference of the stations that are in catalonia, if we want to change or amplify them we can change the coordinates of the box in set_stations script

pollutant      <-"no2"

# we prepare a matrix where we will save the observations:
obs                  <- matrix(,ncol=(nrow(local_stations@data)+1),nrow=0)
df_obs_all           <- data.frame(obs)
colnames(df_obs_all) <- c("date",local_stations@data$ref_obs) #we transform from a matrix to a data frame, with the reference of the station as a name of the col


# finally we extract the observations of certan year_month
for (y_month in year_month) {
  
  netcdf_obs    <- RNetCDF::open.nc(paste0(obs_path, "/sconc", pollutant, "_", y_month, ".nc"))
  
  code_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'station_reference')
  obs_all       <- RNetCDF::var.get.nc(netcdf_obs, "sconcno2")
  
  
  year            <- as.numeric(substr(y_month, 1, 4))
  month           <- as.numeric(substr(y_month, 5, 6))
  num_days        <- length(RNetCDF::var.get.nc(netcdf_obs, "time"))/24
  date_times_loc  <- data_frame_dates( c(year,month,01,00) , c(year,month,num_days,23) )
  
  
  
  pos_local_stations  <- which(code_obs%in%local_stations@data$ref_obs)
  cat_obs             <- obs_all[,pos_local_stations]
  cat_ref             <- code_obs[pos_local_stations]
  
  obs_month=matrix(,ncol=length(cat_obs[1,]),nrow=length(cat_obs[,1])) #cat_obs matriu de 72 col (estacions) i en aquest cas p.ex: 744 (31 dies de generx24h) i fem una obs month buida
  df_obs_month=data.frame(obs_month)
  colnames(df_obs_month) = cat_ref
  df_obs_month[,] = cat_obs
  df_obs_month$date <- date_times_loc$date
  
  df_obs_all              <-merge( df_obs_all, df_obs_month, all=TRUE) #in case there is no data on a certain date, it fills it with NA (rbind.fill)
}

